 library(stringr); library(gplots);
 
 china = read.table('union_peptides_china.tsv', header = T, sep = '\t', as.is=T, quote='')
 chern = read.table('union_peptides_chern.tsv', header = T, sep = '\t', as.is=T, quote='')
 aus = read.table('union_peptides_aus.tsv', header = T, sep = '\t', as.is=T, quote='')

  venn(list( china=china$sequence, chern=chern$sequence, aus = aus$sequence  )) 
  
  chern.uniq     = setdiff(chern$sequence, unique(c(aus$sequence,china$sequence)))
  chern.uniq.ind = match(chern.uniq, chern$sequence)
  write.table(chern[chern.uniq.ind, ], file = 'unique.chern.peptides.tsv',sep='\t', quote = F, row.names = F)
  
  chern$proteins = gsub('\"','',chern$proteins)
  chern.prot = strsplit(chern$proteins[chern.uniq.ind], split = ';') 
  for(i in 1:length(chern.prot)){
    ind = grep('DECOY', chern.prot[[i]])
    if(length(ind)>0) { chern.prot[[i]] = chern.prot[[i]][-ind]  };
    chern.prot[[i]] = unlist(sapply(chern.prot[[i]], function(x){ strsplit(x, split='\\|')[[1]][2:3]},simplify = F))
    names(chern.prot[[i]]) = NULL
    chern.prot[[i]] = unique(chern.prot[[i]])
  }

  
  china.prot = strsplit(china$proteins, split = ';') 
  for(i in 1:length(china.prot)){
    ind = grep('DECOY', china.prot[[i]])
    if(length(ind)>0) { china.prot[[i]] = china.prot[[i]][-ind]  };
    china.prot[[i]] = unlist(sapply(china.prot[[i]], function(x){ strsplit(x, split='\\|')[[1]][2:3]},simplify = F))
    names(china.prot[[i]]) = NULL
    china.prot[[i]] = unique(china.prot[[i]])
  }
  all.china.prot = unlist(china.prot);

  
  aus.prot = strsplit(aus$proteins, split = ';') 
  for(i in 1:length(aus.prot)){
    ind = grep('DECOY', aus.prot[[i]])
    if(length(ind)>0) { aus.prot[[i]] = aus.prot[[i]][-ind]  };
    aus.prot[[i]] = unlist(sapply(aus.prot[[i]], function(x){ strsplit(x, split='\\|')[[1]][2:3]},simplify = F))
    names(aus.prot[[i]]) = NULL
    aus.prot[[i]] = unique(aus.prot[[i]])
  }
  all.aus.prot = unlist(aus.prot);
  
    
  
  all.chern.prot = data.frame(id = unique(unlist(chern.prot)), 
                              peptides='', 
                              in_aus = F, in_china = F,
                              stringsAsFactors = F);
  for(i in 1:nrow(all.chern.prot)){
  #for(i in 1:100){    
    res = sapply(chern.prot, function(x){  all.chern.prot$id[i] %in% x  })
    ind = which(res);
    if(length(ind)==0){ next; }
    all.chern.prot$peptides[i] = paste(chern$sequence[chern.uniq.ind[ind]],collapse = ';')
    all.chern.prot$in_aus[i]   = all.chern.prot$id[i] %in% all.aus.prot;
    all.chern.prot$in_china[i] = all.chern.prot$id[i] %in% all.china.prot;
    if((i %% 100)==0){cat(i,'\n')}
  }
  write.table(all.chern.prot, file = 'unique.chern.prots.tsv',sep='\t', quote = F, row.names = F)
  
  
   